package cs108.adapter;

import java.util.AbstractList;

public final class ArrayAdapter<E> extends AbstractList<E> {
	private final E[] array;
	
	public ArrayAdapter(E[] array) {
		this.array = array;
	}

	@Override
	public E get(int index) {
		return array[index];
	}

	@Override
	public E set(int index, E newValue) {
		E oldValue = array[index];
		array[index] = newValue;
		return oldValue;
	}
	
	@Override
	public int size() {
		return array.length;
	}
}
