package cs108.builder;

import java.util.HashMap;
import java.util.Map;

public final class MatrixBuilder {
	private double[][] elements;
	
	public MatrixBuilder(int r, int c) {
		elements = new double[r][c];
	}

	public double get(int r, int c) {
		return elements[r][c];
	}

	public void set(int r, int c, double v) {
		elements[r][c] = v;
	}

	public double density() {
		int totalElementsCount = 0;
		int nonZeroElementsCount = 0;
		for (double[] row : elements) {
			totalElementsCount += row.length;
			for (double v : row) if (v != 0) nonZeroElementsCount += 1;
		}
		return (double)nonZeroElementsCount / totalElementsCount;
	}
	
	public Matrix build() {
		if (density() >= 0.5)
			return new DenseMatrix(elements);
		else {
			Map<Integer, Double> nonZeroElements = new HashMap<>();
			// TODO compute the non-zero elements
			return new SparseMatrix(nonZeroElements);
		}
	}
}