package cs108.composite;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public final class Group implements Shape {
	private final List<Shape> shapes;
	
	public Group(List<Shape> shapes) {
		this.shapes = List.copyOf(shapes);
	}

	@Override
	public boolean contains(Point p) {
		for (Shape s: shapes) {
			if (s.contains(p))
				return true;
		}
		return false;
	}
}
