package cs108.countingset.decorator2;

import java.util.Collection;
import java.util.Set;

public class CountingSet<E> extends ForwardingSet<E> {
	private int addCount = 0;
	
	public CountingSet(Set<E> s) {
		super(s);
	}
	
	@Override
	public boolean add(E e) {
		addCount += 1;
		return super.add(e);
	}

	@Override
	public boolean addAll(Collection<? extends E> c) {
		addCount += c.size();
		return super.addAll(c);
	}
	
	public int addCount() {
		return addCount;
	}
}
