package cs108.decorator;

public final class Translated implements Shape {
	private final Shape shape;
	private final double dX, dY;
	
	public Translated(Shape shape, double dX, double dY) {
		this.shape = shape;
		this.dX = dX;
		this.dY = dY;
	}

	@Override
	public boolean contains(Point p) {
		return shape.contains(new Point(p.x() - dX, p.y() - dY));
	}
}
